"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.average = void 0;
const shared_1 = require("../../shared");
function average(source, selector) {
    if (selector) {
        return average2(source, selector);
    }
    else {
        return average1(source);
    }
}
exports.average = average;
const average1 = async (source) => {
    let value;
    let count;
    for await (const item of source) {
        value = (value || 0) + item;
        count = (count || 0) + 1;
    }
    if (value === undefined) {
        throw new shared_1.InvalidOperationException(shared_1.ErrorString.NoElements);
    }
    return value / count;
};
const average2 = async (source, func) => {
    let value;
    let count;
    for await (const item of source) {
        value = (value || 0) + func(item);
        count = (count || 0) + 1;
    }
    if (value === undefined) {
        throw new shared_1.InvalidOperationException(shared_1.ErrorString.NoElements);
    }
    return value / count;
};
