"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.concatenate = void 0;
const BasicAsyncEnumerable_1 = require("../BasicAsyncEnumerable");
/**
 * Concatenates two sequences.
 * @param first The first sequence to concatenate.
 * @param second The sequence to concatenate to the first sequence.
 * @returns An IAsyncEnumerable<T> that contains the concatenated elements of the two input sequences.
 */
function concatenate(first, second) {
    async function* iterator() {
        yield* first;
        yield* second;
    }
    return new BasicAsyncEnumerable_1.BasicAsyncEnumerable(iterator);
}
exports.concatenate = concatenate;
