"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.reverse = void 0;
const BasicAsyncEnumerable_1 = require("../BasicAsyncEnumerable");
/**
 * Inverts the order of the elements in a sequence.
 * @param source A sequence of values to reverse.
 * @returns A sequence whose elements correspond to those of the input sequence in reverse order.
 */
function reverse(source) {
    async function* iterator() {
        const values = [];
        for await (const value of source) {
            values.push(value);
        }
        for (let i = values.length - 1; i >= 0; i--) {
            yield values[i];
        }
    }
    return new BasicAsyncEnumerable_1.BasicAsyncEnumerable(iterator);
}
exports.reverse = reverse;
