"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.toArray = void 0;
/**
 * Creates an array from a AsyncIterable<T>.
 * @param source An AsyncIterable<T> to create an array from.
 * @returns An array of elements
 */
async function toArray(source) {
    const array = [];
    for await (const item of source) {
        array.push(item);
    }
    return array;
}
exports.toArray = toArray;
