"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.flattenAsync = void 0;
const BasicAsyncEnumerable_1 = require("../BasicAsyncEnumerable");
function flattenAsync(source, shallow) {
    async function* iterator(sourceInner) {
        for await (const item of sourceInner) {
            // eslint-disable-next-line @typescript-eslint/no-unsafe-member-access
            if (item[Symbol.asyncIterator] !== undefined) {
                // eslint-disable-next-line @typescript-eslint/no-unsafe-assignment
                const items = shallow ? item : iterator(item);
                for await (const inner of items) {
                    yield inner;
                }
            }
            else {
                yield item;
            }
        }
    }
    return new BasicAsyncEnumerable_1.BasicAsyncEnumerable(() => iterator(source));
}
exports.flattenAsync = flattenAsync;
