import { IParallelEnumerable, TypedData } from "../types";
/**
 * Base implementation of IParallelEnumerable<T>
 * @private
 */
export declare class BasicParallelEnumerable<TSource> {
    readonly dataFunc: TypedData<TSource>;
    constructor(dataFunc: TypedData<TSource>);
    [Symbol.asyncIterator](): AsyncIterableIterator<TSource>;
}
/**
 * Workaround for circular reference issues in JS
 * @private
 */
export interface BasicParallelEnumerable<TSource> extends IParallelEnumerable<TSource> {
}
