import { IParallelEnumerable } from "../../types";
/**
 * Determines whether a sequence contains any elements.
 * If predicate is specified, determines whether any element of a sequence satisfies a condition.
 * @param source The IEnumerable<T> to check for emptiness or apply the predicate to.
 * @param predicate A function to test each element for a condition.
 * @returns Whether or not the sequence contains any elements or contains any elements matching the predicate
 */
export declare const any: <TSource>(source: IParallelEnumerable<TSource>, predicate?: ((x: TSource) => boolean) | undefined) => Promise<boolean>;
