"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.min = void 0;
const shared_1 = require("../../shared");
const BasicParallelEnumerable_1 = require("../BasicParallelEnumerable");
const _nextIteration_1 = require("./_nextIteration");
async function min(source, selector) {
    let minInfo;
    if (selector) {
        const dataFunc = _nextIteration_1.nextIteration(source, selector);
        minInfo = await new BasicParallelEnumerable_1.BasicParallelEnumerable(dataFunc)
            .toArray();
    }
    else {
        minInfo = await source.toArray();
    }
    if (minInfo.length === 0) {
        throw new shared_1.InvalidOperationException(shared_1.ErrorString.NoElements);
    }
    return Math.min.apply(null, minInfo);
}
exports.min = min;
