"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ofType = void 0;
const BasicParallelEnumerable_1 = require("../BasicParallelEnumerable");
/**
 * Applies a type filter to a source iteration
 * @param source Async Iteration to Filtery by Type
 * @param type Either value for typeof or a consturctor function
 * @returns Values that match the type string or are instance of type
 */
function ofType(source, type) {
    const typeCheck = typeof type === "string" ?
        ((x) => typeof x === type) :
        ((x) => x instanceof type);
    const data = async () => (await source.toArray()).filter(typeCheck);
    return new BasicParallelEnumerable_1.BasicParallelEnumerable({
        generator: data,
        type: 0 /* PromiseToArray */,
    });
}
exports.ofType = ofType;
