"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.toObject = void 0;
/**
 * Converts an Async Iterable to a key value pair object
 * @param source Iteration to Convert to an Object
 * @param selector Key Selector
 * @returns KVP Object
 */
async function toObject(source, selector) {
    const map = {};
    for await (const value of source) {
        map[selector(value)] = value;
    }
    return map;
}
exports.toObject = toObject;
