"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.min = void 0;
const shared_1 = require("../../shared");
function min(source, selector) {
    if (selector) {
        return min2(source, selector);
    }
    else {
        return min1(source);
    }
}
exports.min = min;
const min1 = (source) => {
    let minItem = null;
    for (const item of source) {
        minItem = Math.min(minItem || Number.POSITIVE_INFINITY, item);
    }
    if (minItem === null) {
        throw new shared_1.InvalidOperationException(shared_1.ErrorString.NoElements);
    }
    else {
        return minItem;
    }
};
const min2 = (source, selector) => {
    let minItem = null;
    for (const item of source) {
        minItem = Math.min(minItem || Number.POSITIVE_INFINITY, selector(item));
    }
    if (minItem === null) {
        throw new shared_1.InvalidOperationException(shared_1.ErrorString.NoElements);
    }
    else {
        return minItem;
    }
};
