"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.selectAsync = void 0;
const fromAsync_1 = require("../../async/static/fromAsync");
function selectAsync(source, selector) {
    if (typeof selector === "function") {
        if (selector.length === 1) {
            return selectAsync1(source, selector);
        }
        else {
            return selectAsync2(source, selector);
        }
    }
    else {
        // eslint-disable-next-line @typescript-eslint/no-unsafe-return
        return selectAsync3(source, selector);
    }
}
exports.selectAsync = selectAsync;
const selectAsync1 = (source, selector) => {
    async function* iterator() {
        for (const value of source) {
            yield selector(value);
        }
    }
    return fromAsync_1.fromAsync(iterator);
};
const selectAsync2 = (source, selector) => {
    async function* iterator() {
        let index = 0;
        for (const value of source) {
            yield selector(value, index);
            index++;
        }
    }
    return fromAsync_1.fromAsync(iterator);
};
const selectAsync3 = (source, key) => {
    async function* iterator() {
        for (const value of source) {
            yield value[key];
        }
    }
    return fromAsync_1.fromAsync(iterator);
};
