"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.flatten = void 0;
const BasicEnumerable_1 = require("../BasicEnumerable");
function flatten(source, shallow) {
    // eslint-disable-next-line no-shadow
    function* iterator(source) {
        for (const item of source) {
            // JS string is an Iterable.
            // We exclude it from being flattened
            // eslint-disable-next-line @typescript-eslint/no-unsafe-member-access
            if (item[Symbol.iterator] !== undefined && typeof item !== "string") {
                yield* shallow ? item : iterator(item);
            }
            else {
                yield item;
            }
        }
    }
    return new BasicEnumerable_1.BasicEnumerable(() => iterator(source));
}
exports.flatten = flatten;
