import { ErrorString, InvalidOperationException } from "../../shared";
import { BasicParallelEnumerable } from "../BasicParallelEnumerable";
import { nextIteration } from "./_nextIteration";
export async function min(source, selector) {
    let minInfo;
    if (selector) {
        const dataFunc = nextIteration(source, selector);
        minInfo = await new BasicParallelEnumerable(dataFunc)
            .toArray();
    }
    else {
        minInfo = await source.toArray();
    }
    if (minInfo.length === 0) {
        throw new InvalidOperationException(ErrorString.NoElements);
    }
    return Math.min.apply(null, minInfo);
}
