/**
 * Creates an array from a IParallelEnumerable<T>.
 * @param source An IParallelEnumerable<T> to create an array from.
 * @returns An array of elements
 */
export function toArray(source) {
    const dataFunc = source.dataFunc;
    switch (dataFunc.type) {
        case 0 /* PromiseToArray */:
            return dataFunc.generator();
        case 1 /* ArrayOfPromises */:
            return Promise.all(dataFunc.generator());
        case 2 /* PromiseOfPromises */:
            return (async () => {
                const data = await dataFunc.generator();
                return Promise.all(data);
            })();
        default:
            throw new Error("Not Implemented");
    }
}
