import { BasicParallelEnumerable } from "../BasicParallelEnumerable";
export function flattenParallel(source, shallow) {
    async function* iterator(sourceInner) {
        for await (const item of sourceInner) {
            // eslint-disable-next-line @typescript-eslint/no-unsafe-member-access
            if (item[Symbol.asyncIterator] !== undefined) {
                // eslint-disable-next-line @typescript-eslint/no-unsafe-assignment
                const items = shallow ? item : iterator(item);
                for await (const inner of items) {
                    yield inner;
                }
            }
            else {
                yield item;
            }
        }
    }
    const generator = async () => {
        const results = [];
        for await (const x of iterator(source)) {
            results.push(x);
        }
        return results;
    };
    return new BasicParallelEnumerable({
        generator,
        type: 0 /* PromiseToArray */,
    });
}
