import { BasicEnumerable } from "../BasicEnumerable";
export function flatten(source, shallow) {
    // eslint-disable-next-line no-shadow
    function* iterator(source) {
        for (const item of source) {
            // JS string is an Iterable.
            // We exclude it from being flattened
            // eslint-disable-next-line @typescript-eslint/no-unsafe-member-access
            if (item[Symbol.iterator] !== undefined && typeof item !== "string") {
                yield* shallow ? item : iterator(item);
            }
            else {
                yield item;
            }
        }
    }
    return new BasicEnumerable(() => iterator(source));
}
